'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 6 March 2003 at 4:02:07 pm'!

!Morph methodsFor: 'layout-properties' stamp: 'jm 3/6/2003 15:56'!
centering: aSymbol
	"Compatability with old layout protocol."

	self cellPositioning: aSymbol.
! !

!Morph methodsFor: 'layout-properties' stamp: 'jm 3/6/2003 15:57'!
inset: aSymbol
	"Compatability with old layout protocol."

	self cellInset: aSymbol.
! !

!Morph methodsFor: 'layout-properties' stamp: 'jm 3/6/2003 16:00'!
orientation: aSymbol
	"Compatability with old layout protocol."

	aSymbol = #vertical ifTrue: [self listDirection: #topToBottom].
	aSymbol = #horizontal ifTrue: [self listDirection: #leftToRight].
! !

!SerialPort methodsFor: 'open/close' stamp: 'jm 10/21/2002 15:55'!
isOpen
	"Return true iff the serial port is open."
	"Details: Try to read zero bytes. If the read primitive fails because the port is not open, it will return nil. If the port is open, the primitive will return 0."

	| buf n |
	port ifNil: [^ false].
	buf _ ByteArray new: 1.
	n _ self primNoErrorReadPort: port into: buf startingAt: 1 count: 0.
	^ n notNil
! !

!SerialPort methodsFor: 'open/close' stamp: 'jm 1/8/2003 17:28'!
openPort: portNumber
	"Open the given serial port, using the settings specified by my instance variables."

	self
		openPort: portNumber
		ifFail: [self error: 'could not open serial port ', portNumber printString].
! !

!SerialPort methodsFor: 'open/close' stamp: 'jm 1/8/2003 17:28'!
openPort: portNumber ifFail: failBlock
	"Open the given serial port, using the settings specified by my instance variables. If the port cannot be opened, such as when it is alreay in use, return the result of evaluating failBlock."

	self close.
	self primClosePort: portNumber.
	(self primOpenPort: portNumber
		baudRate: baudRate
		stopBitsType: stopBitsType
		parityType: parityType
		dataBits: dataBits
		inFlowControlType: inputFlowControlType
		outFlowControlType: outputFlowControlType
		xOnByte: xOnByte
		xOffByte: xOffByte) isNil ifTrue: [^ failBlock value].
	port _ portNumber.
! !

!SerialPort methodsFor: 'input/output' stamp: 'jm 1/8/2003 12:55'!
flushInputBuffer
	"Read and discard bytes until there are no more bytes in the input buffer."

	| buf |
	buf _ ByteArray new: 1000.
	[(self primReadPort: port into: buf startingAt: 1 count: buf size) > 0]
		whileTrue: ["keep reading"].
! !

!SerialPort methodsFor: 'input/output' stamp: 'jm 1/8/2003 12:58'!
next: byteCount
	"Answer a ByteArray of length byteCount with the next byteCount bytes read from this port. Wait indefinitely until enough bytes arrive."

	| buf i count |
	buf _ ByteArray new: byteCount.
	i _ 1.
	[i <= byteCount] whileTrue: [
		count _ self readInto: buf startingAt: i.
		i _ i + count].
	^ buf
! !

!SerialPort methodsFor: 'input/output' stamp: 'jm 1/8/2003 12:51'!
readBytes: byteCount
	"Answer a ByteArray of length byteCount with the next byteCount bytes read from this port. Wait indefinitely until byteCount bytes arrive."

	| buf i count |
	buf _ ByteArray new: byteCount.
	i _ 1.
	[i <= byteCount] whileTrue: [
		count _ self readInto: buf startingAt: i.
		i _ i + count].
	^ buf
! !

!SerialPort methodsFor: 'primitives' stamp: 'jm 3/6/2003 15:44'!
primClosePort: portNumber
	"Try to close the given port. Do nothing if the primitive fails."

	<primitive: 'primitiveSerialPortClose' module: 'SerialPlugin'>
! !

!SerialPort methodsFor: 'primitives' stamp: 'jm 10/21/2002 15:43'!
primNoErrorReadPort: portNumber into: byteArray startingAt: startIndex count: count

	<primitive: 'primitiveSerialPortRead' module: 'SerialPlugin'>
	^ nil
! !

!SerialPort methodsFor: 'primitives' stamp: 'jm 3/6/2003 15:39'!
primReadPort: portNumber into: byteArray startingAt: startIndex count: count

	<primitive: 'primitiveSerialPortRead' module: 'SerialPlugin'>
	^ 0
! !

!SerialPort methodsFor: 'primitives' stamp: 'jm 3/6/2003 15:39'!
primWritePort: portNumber from: byteArray startingAt: startIndex count: count

	<primitive: 'primitiveSerialPortWrite' module: 'SerialPlugin'>
	^ 0
! !

